﻿Type=Class
Version=1.8
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private no As NativeObject = Me
	Private ABPermission As Int
	Private People As List
	Type ABPerson(FirstName As String, LastName As String, Image As Bitmap)
End Sub

Public Sub GetPermission() As Int
	Return ABPermission
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	ABPermission = no.RunMethod("GetPermission",Null).AsNumber
	People.Initialize
End Sub

Public Sub GetContacts As List
	People.Clear
	Dim lst As List = no.RunMethod("getContacts",Null)
	For Each itm As List In lst
		Dim person As ABPerson
		person.Initialize
		person.FirstName = itm.Get(0)
		person.LastName = itm.Get(1)
		If itm.Size > 2 Then
			person.Image = itm.Get(2)
		End If
		People.Add(person)
	Next	
	Return People
End Sub
Sub AddContact(FirstName As String,LastName As String, PhoneNumber As String)
	no.RunMethod("addToContacts:::",Array(FirstName,LastName,PhoneNumber))
End Sub

#If OBJC  
@import AddressBook;

- (NSArray*)getContacts
{
	ABAddressBookRef addressBookRef = ABAddressBookCreateWithOptions(NULL, nil);
	NSArray *allContacts = (__bridge NSArray *)ABAddressBookCopyArrayOfAllPeople(addressBookRef);
	NSString* myNewString = [NSString stringWithFormat:@"%i", allContacts.count];
	NSLog(myNewString);
	NSMutableArray *people = [NSMutableArray arrayWithCapacity:allContacts.count];
	for (int i = 0 ; i != allContacts.count ; i++) {
		NSMutableArray *values = [NSMutableArray arrayWithCapacity:4];
		ABRecordRef person = (__bridge ABRecordRef)[allContacts objectAtIndex:i];
		NSString *firstName = (__bridge NSString*)ABRecordCopyValue(person, kABPersonFirstNameProperty);
		NSString *lastName = (__bridge NSString*)ABRecordCopyValue(person, kABPersonLastNameProperty);
		NSLog(@"%d.%@",i,firstName);
		if (firstName != nil)
		{
	    	[values addObject:firstName];
		} else
		{
			[values addObject:@""];
		}
		if (lastName != nil)
		{
			[values addObject:lastName];
		} else
		{
			[values addObject:@""];
		}
		if (ABPersonHasImageData(person)) {
			NSLog(@"Has Image Data");
	        NSData *contactImageData = (__bridge NSData *)ABPersonCopyImageDataWithFormat(person, kABPersonImageFormatThumbnail);
	        //NSData  *imgData = (NSData *)ABPersonCopyImageData(person);

			UIImage  *img = [UIImage imageWithData:contactImageData];
	        [values addObject:img];
		}
		
		[people addObject:values];
	}

	return people;
}

- (int)GetPermission
{
	int retVal;
  if (ABAddressBookGetAuthorizationStatus() == kABAuthorizationStatusDenied ||
      ABAddressBookGetAuthorizationStatus() == kABAuthorizationStatusRestricted)
	{
    //1
    NSLog(@"Denied");
	retVal = 1;
  } else if (ABAddressBookGetAuthorizationStatus() == kABAuthorizationStatusAuthorized)
  {
    //2
    NSLog(@"Authorized");
	retVal = 2;
  } else 
  { 
		//ABAddressBookGetAuthorizationStatus() == kABAuthorizationStatusNotDetermined
    	ABAddressBookRequestAccessWithCompletion(ABAddressBookCreateWithOptions(NULL, nil), ^(bool granted, CFErrorRef error) {
	    	if (!granted){
			    //4
			    NSLog(@"Just denied");
			    //retVal = 4;
				return;
			}
		  //5
		  NSLog(@"Just authorized");
		  //retVal = 5;
		});
    NSLog(@"Not determined");
	retVal = 6;
  }
  return retVal;
}


- (void)addToContacts: (NSString *) FirstName :(NSString *) LastName :(NSString *) PhoneNumber
{

ABAddressBookRef addressBookRef = ABAddressBookCreateWithOptions(NULL, nil);
ABRecordRef person = ABPersonCreate();
ABRecordSetValue(person, kABPersonFirstNameProperty, (__bridge CFStringRef)FirstName, nil);
ABRecordSetValue(person, kABPersonLastNameProperty, (__bridge CFStringRef)LastName, nil);

ABMutableMultiValueRef phoneNumbers = ABMultiValueCreateMutable(kABPersonPhoneProperty);
ABMultiValueAddValueAndLabel(phoneNumbers, (__bridge CFStringRef)PhoneNumber, kABPersonPhoneMainLabel, NULL);
ABRecordSetValue(person, kABPersonPhoneProperty, phoneNumbers, nil);

BOOL isAdded = ABAddressBookAddRecord(addressBookRef, person, nil);

if(isAdded){
		
		NSLog(@"added..");
	}

BOOL isSaved = ABAddressBookSave(addressBookRef, nil);

if(isSaved){
		
		NSLog(@"saved..");
	}
}

#End if
